"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ImmutableXClient = void 0;
var wallet_1 = __importDefault(require("../../wallet"));
var imx_link_crypto_1 = require("@imtbl/imx-link-crypto");
var imx_link_types_1 = require("@imtbl/imx-link-types");
var fp_1 = require("../../../libs/fp");
var utils_1 = require("../../../libs/utils");
var auto_bind_1 = __importDefault(require("auto-bind"));
var axios_1 = __importDefault(require("axios"));
var ethers_1 = require("ethers");
var A = __importStar(require("fp-ts/Array"));
var E = __importStar(require("fp-ts/Either"));
var function_1 = require("fp-ts/function");
var T = __importStar(require("fp-ts/Task"));
var TE = __importStar(require("fp-ts/TaskEither"));
var https = __importStar(require("https"));
var query_string_1 = __importDefault(require("query-string"));
/**
 * Immutable X REST API Client
 */
var ImmutableXClient = /** @class */ (function () {
    function ImmutableXClient(publicApiUrl, wallet, contractAddress, _address, _starkPublicKey) {
        this.publicApiUrl = publicApiUrl;
        this.wallet = wallet;
        this.contractAddress = contractAddress;
        this._address = _address;
        this._starkPublicKey = _starkPublicKey;
        axios_1.default.defaults.baseURL = this.publicApiUrl;
        this.agent = new https.Agent();
        auto_bind_1.default(this);
    }
    ImmutableXClient.buildF = function (params) {
        return fp_1.taskEitherWithError(function () { return ImmutableXClient.build(params); });
    };
    ImmutableXClient.build = function (_a) {
        var publicApiUrl = _a.publicApiUrl, signer = _a.signer, starkContractAddress = _a.starkContractAddress, gasLimit = _a.gasLimit, gasPrice = _a.gasPrice;
        return __awaiter(this, void 0, void 0, function () {
            var parsedGasLimit, parsedGasPrice, wallet, contractAddressT, starkPublicKey, address;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!(signer && starkContractAddress)) return [3 /*break*/, 3];
                        parsedGasLimit = gasLimit ? ethers_1.BigNumber.from(gasLimit) : undefined;
                        parsedGasPrice = gasPrice ? ethers_1.BigNumber.from(gasPrice) : undefined;
                        wallet = new wallet_1.default(signer, parsedGasLimit, parsedGasPrice);
                        return [4 /*yield*/, wallet.controller.account('starkex', 'immutablex', '1')];
                    case 1:
                        _b.sent();
                        contractAddressT = fp_1.valueOrThrow(imx_link_types_1.EthAddress.decode(starkContractAddress));
                        starkPublicKey = fp_1.valueOrThrow(imx_link_types_1.HexadecimalString.decode(wallet.controller.starkPublicKey));
                        return [4 /*yield*/, wallet.controller.getAddress()];
                    case 2:
                        address = _b.sent();
                        return [2 /*return*/, new ImmutableXClient(publicApiUrl, wallet, contractAddressT, address, starkPublicKey)];
                    case 3: return [2 /*return*/, new ImmutableXClient(publicApiUrl, {}, {}, {}, {})];
                }
            });
        });
    };
    Object.defineProperty(ImmutableXClient.prototype, "address", {
        get: function () {
            return this._address;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ImmutableXClient.prototype, "starkPublicKey", {
        get: function () {
            return this._starkPublicKey;
        },
        enumerable: false,
        configurable: true
    });
    ImmutableXClient.prototype.buildOptions = function () {
        return {
            httpsAgent: this.agent,
            headers: {
                'Content-Type': 'application/json',
            },
        };
    };
    ImmutableXClient.prototype.get = function (path, decode) {
        var _this = this;
        return function_1.pipe(fp_1.taskEitherWithError(function () { return axios_1.default.get("" + path, _this.buildOptions()); }), TE.chain(function (r) { return function_1.pipe(decode(r.data), E.mapLeft(fp_1.errorsToError), TE.fromEither); }));
    };
    ImmutableXClient.prototype.post = function (path, data, decode) {
        var _this = this;
        return function_1.pipe(fp_1.taskEitherWithError(function () { return axios_1.default.post("" + path, data, _this.buildOptions()); }), TE.chain(function (r) { return function_1.pipe(decode(r.data), E.mapLeft(fp_1.errorsToError), TE.fromEither); }));
    };
    ImmutableXClient.prototype.registerImxF = function (_a) {
        var _this = this;
        var etherKey = _a.etherKey, starkPublicKey = _a.starkPublicKey;
        return function_1.pipe({
            body: {
                ether_key: etherKey.toLowerCase(),
                stark_key: starkPublicKey,
                nonce: 0,
            },
        }, TE.of, TE.bind('signature', function (_a) {
            var body = _a.body;
            return _this.wallet.controller.signUserRegistration({
                etherKey: body.ether_key,
                starkPublicKey: body.stark_key,
                nonce: String(body.nonce),
            });
        }), TE.chain(function (_a) {
            var signature = _a.signature, body = _a.body;
            var data = JSON.stringify(__assign(__assign({}, body), { stark_signature: signature }));
            return _this.post('users', data, imx_link_types_1.ImmutableMethodResults.ImmutableRegisterResultCodec.decode);
        }));
    };
    ImmutableXClient.prototype.getUserF = function (params) {
        return this.get('users/' + params.user, imx_link_types_1.ImmutableMethodResults.ImmutableGetUserResultCodec.decode);
    };
    ImmutableXClient.prototype.getUser = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableGetUserParamsCodec.decode, this.getUserF)];
            });
        });
    };
    ImmutableXClient.prototype.registerImx = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableRegisterParamsCodec.decode, this.registerImxF)];
            });
        });
    };
    ImmutableXClient.prototype.isRegisteredF = function (params) {
        return function_1.pipe(this.getUserF(params), TE.fold(function () { return T.of(false); }, function () { return T.of(true); }), T.chain(function (result) { return TE.of(result); }));
    };
    ImmutableXClient.prototype.isRegistered = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableGetUserParamsCodec.decode, this.isRegisteredF)];
            });
        });
    };
    ImmutableXClient.prototype.isRegisteredStarkF = function (starkPublicKey) {
        return function_1.pipe(this.wallet.getEthKey(this.contractAddress, starkPublicKey), TE.fold(function () { return T.of(false); }, function () { return T.of(true); }));
    };
    ImmutableXClient.prototype.isRegisteredStark = function (starkPublicKey) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.isRegisteredStarkF(starkPublicKey)()];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    ImmutableXClient.prototype.registerF = function (params) {
        return function_1.pipe(this.registerImxF(params), TE.map(function (result) { return result.tx_hash; }));
    };
    ImmutableXClient.prototype.register = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableRegisterParamsCodec.decode, this.registerF)];
            });
        });
    };
    ImmutableXClient.prototype.registerStarkF = function (_a) {
        var etherKey = _a.etherKey, starkPublicKey = _a.starkPublicKey, operatorSignature = _a.operatorSignature;
        return function_1.pipe(this.wallet.controller.register({
            contractAddress: this.contractAddress,
            etherKey: etherKey,
            starkPublicKey: starkPublicKey,
            operatorSignature: operatorSignature,
        }), TE.chain(this.wallet.sendTransactionF));
    };
    ImmutableXClient.prototype.registerStark = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableStarkRegisterParamsCodec.decode, this.registerStarkF)];
            });
        });
    };
    ImmutableXClient.prototype.mintNFTF = function (_a) {
        var tokenAddress = _a.tokenAddress;
        return function_1.pipe(this.wallet.controller.mintNFT(tokenAddress), TE.chain(this.wallet.sendTransactionF));
    };
    ImmutableXClient.prototype.mintNFT = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableMintNFTParamsCodec.decode, this.mintNFTF)];
            });
        });
    };
    ImmutableXClient.prototype.approveNFTF = function (params) {
        return function_1.pipe(this.wallet.controller.approveNFT(__assign(__assign({}, params), { contractAddress: this.contractAddress })), TE.chain(this.wallet.sendTransactionF));
    };
    ImmutableXClient.prototype.approveNFT = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableStarkApproveNFTParamsCodec.decode, this.approveNFTF)];
            });
        });
    };
    ImmutableXClient.prototype.depositF = function (_a) {
        var _this = this;
        var user = _a.user, token = _a.token, quantity = _a.quantity;
        var data = JSON.stringify({
            user: user,
            token: {
                type: token.type,
                data: this.getTokenBody(token),
            },
            amount: quantity.toString(),
        });
        return function_1.pipe(TE.bindTo('signableDepositResult')(this.post('signable-deposit-details', data, imx_link_types_1.ImmutableMethodResults.ImmutableGetSignableDepositResultCodec.decode)), TE.bind('vaultId', function (_a) {
            var signableDepositResult = _a.signableDepositResult;
            return function_1.pipe(imx_link_types_1.PositiveIntegerString.decode(String(signableDepositResult.vault_id)), E.mapLeft(fp_1.errorsToError), TE.fromEither);
        }), TE.bind('transaction', function (_a) {
            var vaultId = _a.vaultId, signableDepositResult = _a.signableDepositResult;
            return _this.wallet.controller.depositF({
                contractAddress: _this.contractAddress,
                starkPublicKey: signableDepositResult.stark_key,
                quantity: quantity,
                token: token,
                vaultId: vaultId,
            });
        }), TE.chain(function (_a) {
            var transaction = _a.transaction;
            return _this.wallet.sendTransactionF(transaction);
        }));
    };
    ImmutableXClient.prototype.deposit = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableGetSignableDepositParamsCodec.decode, this.depositF)];
            });
        });
    };
    ImmutableXClient.prototype.depositCancel = function (starkPublicKey, token, vaultId) {
        return __awaiter(this, void 0, void 0, function () {
            var assetID, nonce, _a, body, signature, data, res, err_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        assetID = imx_link_crypto_1.getAssetID(token).val;
                        _a = parseInt;
                        return [4 /*yield*/, this.getLastAvailableNonce(starkPublicKey)];
                    case 1:
                        nonce = _a.apply(void 0, [(_b.sent()).Nonce]);
                        body = {
                            stark_key: starkPublicKey,
                            asset_id: assetID,
                            vault_id: parseInt(vaultId),
                            nonce: nonce,
                        };
                        return [4 /*yield*/, this.wallet.controller.signStark(body)];
                    case 2:
                        signature = _b.sent();
                        data = JSON.stringify(__assign(__assign({}, body), { stark_signature: signature }));
                        _b.label = 3;
                    case 3:
                        _b.trys.push([3, 5, , 6]);
                        return [4 /*yield*/, axios_1.default.post('cancel-deposit', data, this.buildOptions())];
                    case 4:
                        res = _b.sent();
                        return [2 /*return*/, res.data];
                    case 5:
                        err_1 = _b.sent();
                        throw utils_1.formatError(err_1);
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    ImmutableXClient.prototype.depositReclaim = function (starkPublicKey, token, vaultId) {
        return __awaiter(this, void 0, void 0, function () {
            var assetID, nonce, _a, body, signature, data, res, err_2;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        assetID = imx_link_crypto_1.getAssetID(token).val;
                        _a = parseInt;
                        return [4 /*yield*/, this.getLastAvailableNonce(starkPublicKey)];
                    case 1:
                        nonce = _a.apply(void 0, [(_b.sent()).Nonce]);
                        body = {
                            stark_key: starkPublicKey,
                            asset_id: assetID,
                            vault_id: parseInt(vaultId),
                            nonce: nonce,
                        };
                        return [4 /*yield*/, this.wallet.controller.signStark(body)];
                    case 2:
                        signature = _b.sent();
                        data = JSON.stringify(__assign(__assign({}, body), { stark_signature: signature }));
                        _b.label = 3;
                    case 3:
                        _b.trys.push([3, 5, , 6]);
                        return [4 /*yield*/, axios_1.default.post('reclaim-deposit', data, this.buildOptions())];
                    case 4:
                        res = _b.sent();
                        return [2 /*return*/, res.data];
                    case 5:
                        err_2 = _b.sent();
                        throw utils_1.formatError(err_2);
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    ImmutableXClient.prototype.prepareWithdrawalF = function (_a) {
        var _this = this;
        var user = _a.user, token = _a.token, quantity = _a.quantity;
        return function_1.pipe(TE.bindTo('signableWithdrawalResult')(this.post('signable-withdrawal-details', JSON.stringify({
            user: user,
            token: {
                type: token.type.toUpperCase() === 'MINTABLE_ERC721' ? imx_link_types_1.ERC721TokenType.ERC721 : token.type,
                data: this.getTokenBody(token),
            },
            amount: quantity.toString(),
        }), imx_link_types_1.ImmutableMethodResults.ImmutableGetSignableWithdrawalResultCodec.decode)), TE.bind('signature', function (_a) {
            var signableWithdrawalResult = _a.signableWithdrawalResult;
            return _this.wallet.controller.signWithdraw(signableWithdrawalResult.stark_key, String(signableWithdrawalResult.vault_id), token, quantity, String(signableWithdrawalResult.nonce));
        }), TE.bind('result', function (_a) {
            var signableWithdrawalResult = _a.signableWithdrawalResult, signature = _a.signature;
            return _this.post('withdrawals', JSON.stringify({
                stark_key: signableWithdrawalResult.stark_key,
                amount: quantity.toString(),
                asset_id: signableWithdrawalResult.asset_id,
                vault_id: signableWithdrawalResult.vault_id,
                nonce: signableWithdrawalResult.nonce,
                stark_signature: signature,
            }), imx_link_types_1.ImmutableMethodResults.ImmutableWithdrawalResultCodec.decode);
        }), TE.map(function (_a) {
            var result = _a.result;
            return result;
        }));
    };
    ImmutableXClient.prototype.prepareWithdrawal = function (params) {
        return this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutablePrepareWithdrawalParamsCodec.decode, this.prepareWithdrawalF);
    };
    ImmutableXClient.prototype.completeWithdrawalF = function (_a) {
        var starkPublicKey = _a.starkPublicKey, token = _a.token;
        return function_1.pipe(this.wallet.controller.withdrawal(this.contractAddress, starkPublicKey, token), TE.chain(this.wallet.sendTransactionF));
    };
    ImmutableXClient.prototype.completeWithdrawal = function (params) {
        return this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableCompleteWithdrawalParamsCodec.decode, this.completeWithdrawalF);
    };
    ImmutableXClient.prototype.transferF = function (_a) {
        var _this = this;
        var sender = _a.sender, token = _a.token, quantity = _a.quantity, receiver = _a.receiver;
        return function_1.pipe(TE.bindTo('signableTransferResult')(this.post('signable-transfer-details', JSON.stringify({
            sender: sender,
            token: {
                type: token.type,
                data: this.getTokenBody(token),
            },
            amount: quantity.toString(),
            receiver: receiver,
        }), imx_link_types_1.ImmutableMethodResults.ImmutableGetSignableTransferResultCodec.decode)), TE.bind('signature', function (_a) {
            var signableTransferResult = _a.signableTransferResult;
            return _this.wallet.controller.transfer({
                starkPublicKey: signableTransferResult.sender_stark_key,
                vaultId: signableTransferResult.sender_vault_id,
            }, {
                starkPublicKey: signableTransferResult.receiver_stark_key,
                vaultId: signableTransferResult.receiver_vault_id,
            }, token, signableTransferResult.amount, String(signableTransferResult.nonce), String(signableTransferResult.expiration_timestamp));
        }), TE.bind('result', function (_a) {
            var signableTransferResult = _a.signableTransferResult, signature = _a.signature;
            return _this.post('transfers', JSON.stringify({
                sender_stark_key: signableTransferResult.sender_stark_key,
                sender_vault_id: signableTransferResult.sender_vault_id,
                receiver_stark_key: signableTransferResult.receiver_stark_key,
                receiver_vault_id: signableTransferResult.receiver_vault_id,
                amount: signableTransferResult.amount.toString(),
                asset_id: imx_link_crypto_1.getAssetID(token).val,
                expiration_timestamp: signableTransferResult.expiration_timestamp,
                nonce: signableTransferResult.nonce,
                stark_signature: signature,
            }), imx_link_types_1.ImmutableMethodResults.ImmutableTransferResultCodec.decode);
        }), TE.map(function (_a) {
            var result = _a.result;
            return result;
        }));
    };
    ImmutableXClient.prototype.transfer = function (params) {
        return this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableTransferParamsCodec.decode, this.transferF);
    };
    ImmutableXClient.prototype.mintF = function (params) {
        var _this = this;
        return function_1.pipe(params.mints, A.traverse(TE.taskEither)(function (mint) {
            return function_1.pipe(mint.tokens, A.map(function (token) { return ({
                type: imx_link_types_1.ERC721TokenType.ERC721,
                data: {
                    id: token.data.id,
                    blueprint: token.data.blueprint,
                    token_address: token.data.tokenAddress,
                },
            }); }), function (tokens) { return ({
                result: {
                    ether_key: mint.etherKey,
                    tokens: tokens,
                    nonce: parseInt(mint.nonce),
                    auth_signature: '',
                },
            }); }, TE.of, TE.bind('auth_signature', function (_a) {
                var result = _a.result;
                return fp_1.taskEitherWithError(function () { return _this.wallet.controller.sign(result); });
            }), TE.map(function (_a) {
                var result = _a.result, auth_signature = _a.auth_signature;
                return ({
                    user: result.ether_key,
                    tokens: result.tokens,
                    nonce: parseInt(mint.nonce),
                    auth_signature: auth_signature,
                });
            }));
        }), TE.chain(function (mints) {
            return _this.post('mints', JSON.stringify({
                mints: mints,
            }), imx_link_types_1.ImmutableMethodResults.ImmutableOffchainMintResultCodec.decode);
        }));
    };
    ImmutableXClient.prototype.mint = function (params) {
        return this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableOffchainMintParamsCodec.decode, this.mintF);
    };
    ImmutableXClient.prototype.createOrderRequestF = function (_a) {
        var _this = this;
        var user = _a.user, tokenSell = _a.tokenSell, tokenBuy = _a.tokenBuy, amountSell = _a.amountSell, amountBuy = _a.amountBuy;
        return function_1.pipe(TE.bindTo('signableOrderResult')(this.post('signable-order-details', JSON.stringify({
            user: user,
            token_sell: {
                type: tokenSell.type,
                data: this.getTokenBody(tokenSell),
            },
            amount_sell: amountSell.toString(),
            token_buy: {
                type: tokenBuy.type,
                data: this.getTokenBody(tokenBuy),
            },
            amount_buy: amountBuy.toString(),
        }), imx_link_types_1.ImmutableMethodResults.ImmutableGetSignableOrderResultCodec.decode)), TE.bind('sellParams', function (_a) {
            var signableOrderResult = _a.signableOrderResult;
            return TE.of({
                vaultId: signableOrderResult.vault_id_sell,
                token: tokenSell,
                quantity: signableOrderResult.amount_sell,
            });
        }), TE.bind('buyParams', function (_a) {
            var signableOrderResult = _a.signableOrderResult;
            return TE.of({
                vaultId: signableOrderResult.vault_id_buy,
                token: tokenBuy,
                quantity: signableOrderResult.amount_buy,
            });
        }), TE.bind('signature', function (_a) {
            var signableOrderResult = _a.signableOrderResult, sellParams = _a.sellParams, buyParams = _a.buyParams;
            return _this.wallet.controller.createOrder(signableOrderResult.stark_key, sellParams, buyParams, signableOrderResult.asset_id_sell, signableOrderResult.asset_id_buy, signableOrderResult.nonce, signableOrderResult.expiration_timestamp);
        }), TE.map(function (_a) {
            var signableOrderResult = _a.signableOrderResult, sellParams = _a.sellParams, buyParams = _a.buyParams, signature = _a.signature;
            return ({
                signableOrderResult: signableOrderResult,
                sellParams: sellParams,
                buyParams: buyParams,
                signature: signature,
            });
        }));
    };
    ImmutableXClient.prototype.createOrderF = function (_a) {
        var _this = this;
        var user = _a.user, tokenSell = _a.tokenSell, tokenBuy = _a.tokenBuy, amountSell = _a.amountSell, amountBuy = _a.amountBuy;
        return function_1.pipe(this.createOrderRequestF({
            user: user,
            tokenSell: tokenSell,
            tokenBuy: tokenBuy,
            amountSell: amountSell,
            amountBuy: amountBuy,
        }), TE.bind('result', function (_a) {
            var signableOrderResult = _a.signableOrderResult, sellParams = _a.sellParams, buyParams = _a.buyParams, signature = _a.signature;
            return _this.post('orders', JSON.stringify({
                stark_key: signableOrderResult.stark_key,
                amount_sell: signableOrderResult.amount_sell.toString(),
                asset_id_sell: signableOrderResult.asset_id_sell,
                vault_id_sell: sellParams.vaultId,
                amount_buy: signableOrderResult.amount_buy.toString(),
                asset_id_buy: signableOrderResult.asset_id_buy,
                vault_id_buy: buyParams.vaultId,
                expiration_timestamp: signableOrderResult.expiration_timestamp,
                nonce: signableOrderResult.nonce,
                stark_signature: signature,
            }), imx_link_types_1.ImmutableMethodResults.ImmutableCreateOrderResultCodec.decode);
        }), TE.map(function (_a) {
            var result = _a.result;
            return result;
        }));
    };
    ImmutableXClient.prototype.createOrder = function (params) {
        return this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableGetSignableOrderParamsCodec.decode, this.createOrderF);
    };
    ImmutableXClient.prototype.cancelOrder = function (starkPublicKey, orderId) {
        return __awaiter(this, void 0, void 0, function () {
            var nonce, _a, body, signature, data, res, err_3;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = parseInt;
                        return [4 /*yield*/, this.getLastAvailableNonce(starkPublicKey)];
                    case 1:
                        nonce = _a.apply(void 0, [(_b.sent()).Nonce]);
                        body = {
                            stark_key: starkPublicKey,
                            order_id: parseInt(orderId),
                            nonce: nonce,
                        };
                        return [4 /*yield*/, this.wallet.controller.signStark(body)];
                    case 2:
                        signature = _b.sent();
                        data = JSON.stringify(__assign(__assign({}, body), { stark_signature: signature }));
                        _b.label = 3;
                    case 3:
                        _b.trys.push([3, 5, , 6]);
                        return [4 /*yield*/, axios_1.default.post('cancel-order', data, this.buildOptions())];
                    case 4:
                        res = _b.sent();
                        return [2 /*return*/, res.data];
                    case 5:
                        err_3 = _b.sent();
                        throw utils_1.formatError(err_3);
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    ImmutableXClient.prototype.createTradeF = function (_a) {
        var _this = this;
        var user = _a.user, tokenSell = _a.tokenSell, tokenBuy = _a.tokenBuy, amountSell = _a.amountSell, amountBuy = _a.amountBuy, orderId = _a.orderId;
        return function_1.pipe(this.createOrderRequestF({
            user: user,
            tokenSell: tokenSell,
            tokenBuy: tokenBuy,
            amountSell: amountSell,
            amountBuy: amountBuy,
        }), TE.bind('result', function (_a) {
            var signableOrderResult = _a.signableOrderResult, sellParams = _a.sellParams, buyParams = _a.buyParams, signature = _a.signature;
            return _this.post('trades', JSON.stringify({
                stark_key: signableOrderResult.stark_key,
                amount_sell: signableOrderResult.amount_sell.toString(),
                asset_id_sell: signableOrderResult.asset_id_sell,
                vault_id_sell: sellParams.vaultId,
                amount_buy: signableOrderResult.amount_buy.toString(),
                asset_id_buy: signableOrderResult.asset_id_buy,
                vault_id_buy: buyParams.vaultId,
                expiration_timestamp: signableOrderResult.expiration_timestamp,
                nonce: signableOrderResult.nonce,
                stark_signature: signature,
                order_id: orderId,
            }), imx_link_types_1.ImmutableMethodResults.ImmutableCreateTradeResultCodec.decode);
        }), TE.map(function (_a) {
            var result = _a.result;
            return result;
        }));
    };
    ImmutableXClient.prototype.createTrade = function (params) {
        return this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableGetSignableTradeParamsCodec.decode, this.createTradeF);
    };
    ImmutableXClient.prototype.getBalancesF = function (params) {
        return this.get('balances/' + params.user, imx_link_types_1.ImmutableMethodResults.ImmutableGetBalancesResultCodec.decode);
    };
    ImmutableXClient.prototype.getBalances = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableGetBalancesParamsCodec.decode, this.getBalancesF)];
            });
        });
    };
    ImmutableXClient.prototype.getVaults = function (starkPublicKey) {
        return __awaiter(this, void 0, void 0, function () {
            var data, res, err_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        data = JSON.stringify({
                            stark_key: starkPublicKey,
                        });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, axios_1.default.post('get-vaults', data, this.buildOptions())];
                    case 2:
                        res = _a.sent();
                        return [2 /*return*/, res.data];
                    case 3:
                        err_4 = _a.sent();
                        throw utils_1.formatError(err_4);
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    ImmutableXClient.prototype.getOrderF = function (_a) {
        var orderId = _a.orderId;
        return this.get("orders/" + orderId, imx_link_types_1.ImmutableMethodResults.ImmutableGetOrderResultCodec.decode);
    };
    ImmutableXClient.prototype.getOrder = function (params) {
        return this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableGetOrderParamsCodec.decode, this.getOrderF);
    };
    ImmutableXClient.prototype.getOrdersF = function (query) {
        if (query === void 0) { query = {}; }
        var url = query_string_1.default.stringifyUrl({
            url: 'orders',
            query: query,
        });
        return this.get(url, imx_link_types_1.ImmutableMethodResults.ImmutableGetOrdersResultCodec.decode);
    };
    ImmutableXClient.prototype.getOrders = function (params) {
        if (params === void 0) { params = {}; }
        return this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableGetOrdersParamsCodec.decode, this.getOrdersF);
    };
    ImmutableXClient.prototype.getAssetsF = function (query) {
        var url = query_string_1.default.stringifyUrl({
            url: "assets",
            query: query,
        });
        return this.get(url, imx_link_types_1.ImmutableMethodResults.ImmutableGetAssetsResultCodec.decode);
    };
    ImmutableXClient.prototype.getAssets = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableGetAssetsParamsCodec.decode, this.getAssetsF)];
            });
        });
    };
    ImmutableXClient.prototype.getAssetF = function (_a) {
        var address = _a.address, id = _a.id;
        return this.get("assets/" + address.toLowerCase() + "/" + id, imx_link_types_1.ImmutableMethodResults.ImmutableAssetCodec.decode);
    };
    ImmutableXClient.prototype.getAsset = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableGetAssetParamsCodec.decode, this.getAssetF)];
            });
        });
    };
    ImmutableXClient.prototype.getApplicationsF = function (query) {
        if (query === void 0) { query = {}; }
        var url = query_string_1.default.stringifyUrl({
            url: 'applications',
            query: query,
        });
        return this.get(url, imx_link_types_1.ImmutableMethodResults.ImmutableGetApplicationsResultCodec.decode);
    };
    ImmutableXClient.prototype.getApplications = function (params) {
        if (params === void 0) { params = {}; }
        return this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableGetApplicationsParamsCodec.decode, this.getApplicationsF);
    };
    ImmutableXClient.prototype.getTradeF = function (_a) {
        var id = _a.id;
        return this.get("trades/" + id, imx_link_types_1.ImmutableMethodResults.ImmutableTradeCodec.decode);
    };
    ImmutableXClient.prototype.getTrade = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableGetTradeParamsCodec.decode, this.getTradeF)];
            });
        });
    };
    ImmutableXClient.prototype.getCollectionsF = function (query) {
        var url = query_string_1.default.stringifyUrl({
            url: "collections",
            query: query,
        });
        return this.get(url, imx_link_types_1.ImmutableMethodResults.ImmutableGetCollectionsResultCodec.decode);
    };
    ImmutableXClient.prototype.getCollections = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableGetCollectionsParamsCodec.decode, this.getCollectionsF)];
            });
        });
    };
    ImmutableXClient.prototype.getCollectionF = function (_a) {
        var address = _a.address;
        return this.get("collections/" + address, imx_link_types_1.ImmutableMethodResults.ImmutableCollectionCodec.decode);
    };
    ImmutableXClient.prototype.getCollection = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableGetCollectionParamsCodec.decode, this.getCollectionF)];
            });
        });
    };
    ImmutableXClient.prototype.getDepositsF = function (query) {
        if (query === void 0) { query = {}; }
        var url = query_string_1.default.stringifyUrl({
            url: 'deposits',
            query: query,
        });
        return this.get(url, imx_link_types_1.ImmutableMethodResults.ImmutableGetDepositsResultCodec.decode);
    };
    ImmutableXClient.prototype.getDeposits = function (params) {
        if (params === void 0) { params = {}; }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, fp_1.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableGetDepositsParamsCodec.decode, this.getDepositsF)];
            });
        });
    };
    ImmutableXClient.prototype.getDepositF = function (_a) {
        var id = _a.id;
        return this.get("deposits/" + id, imx_link_types_1.ImmutableMethodResults.ImmutableDepositCodec.decode);
    };
    ImmutableXClient.prototype.getDeposit = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableGetDepositParamsCodec.decode, this.getDepositF)];
            });
        });
    };
    ImmutableXClient.prototype.getTransferF = function (_a) {
        var id = _a.id;
        return this.get("transfers/" + id, imx_link_types_1.ImmutableMethodResults.ImmutableTransferCodec.decode);
    };
    ImmutableXClient.prototype.getTransfer = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableGetTransferParamsCodec.decode, this.getTransferF)];
            });
        });
    };
    ImmutableXClient.prototype.getWithdrawalF = function (_a) {
        var id = _a.id;
        return this.get("Withdrawals/" + id, imx_link_types_1.ImmutableMethodResults.ImmutableWithdrawalCodec.decode);
    };
    ImmutableXClient.prototype.getWithdrawal = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableGetWithdrawalParamsCodec.decode, this.getWithdrawalF)];
            });
        });
    };
    ImmutableXClient.prototype.getWithdrawalsF = function (query) {
        if (query === void 0) { query = {}; }
        var url = query_string_1.default.stringifyUrl({
            url: 'withdrawals',
            query: query,
        });
        return this.get(url, imx_link_types_1.ImmutableMethodResults.ImmutableGetWithdrawalsResultCodec.decode);
    };
    ImmutableXClient.prototype.getWithdrawals = function (params) {
        if (params === void 0) { params = {}; }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, fp_1.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableGetWithdrawalsParamsCodec.decode, this.getWithdrawalsF)];
            });
        });
    };
    ImmutableXClient.prototype.getTransfersF = function (query) {
        if (query === void 0) { query = {}; }
        var url = query_string_1.default.stringifyUrl({
            url: 'transfers',
            query: query,
        });
        return this.get(url, imx_link_types_1.ImmutableMethodResults.ImmutableGetTransfersResultCodec.decode);
    };
    ImmutableXClient.prototype.getTransfers = function (params) {
        if (params === void 0) { params = {}; }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, fp_1.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableGetTransfersParamsCodec.decode, this.getTransfersF)];
            });
        });
    };
    ImmutableXClient.prototype.getTradesF = function (query) {
        if (query === void 0) { query = {}; }
        var url = query_string_1.default.stringifyUrl({
            url: 'trades',
            query: query,
        });
        return this.get(url, imx_link_types_1.ImmutableMethodResults.ImmutableGetTradesResultCodec.decode);
    };
    ImmutableXClient.prototype.getPaginatedResults = function (params, fn) {
        var M = A.getMonoid();
        var loadData = function (params, result) {
            return function_1.pipe(fn(params), TE.chain(function (data) {
                return data.cursor
                    ? loadData(__assign(__assign({}, params), { cursor: data.cursor }), M.concat(result, data.result))
                    : TE.of(M.concat(result, data.result));
            }));
        };
        return loadData(params, []);
    };
    ImmutableXClient.prototype.getTrades = function (params) {
        if (params === void 0) { params = {}; }
        return this.decodeForFunction(params, imx_link_types_1.ImmutableMethodParams.ImmutableGetTradesParamsCodec.decode, this.getTradesF);
    };
    ImmutableXClient.prototype.getLastAvailableNonce = function (starkPublicKey) {
        return __awaiter(this, void 0, void 0, function () {
            var data, nonce, res, err_5;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        data = JSON.stringify({
                            stark_key: starkPublicKey,
                        });
                        nonce = 0;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, axios_1.default.post('get-last-available-nonce', data, this.buildOptions())];
                    case 2:
                        res = _a.sent();
                        nonce = 'nonce' in res.data.result ? res.data.result.nonce : 0; // @x/core/api/interface.go
                        return [3 /*break*/, 4];
                    case 3:
                        err_5 = _a.sent();
                        throw utils_1.formatError(err_5);
                    case 4: return [2 /*return*/, { Nonce: String(nonce) }];
                }
            });
        });
    };
    ImmutableXClient.prototype.getTokenBody = function (token) {
        if (token.type.toUpperCase() === 'ETH') {
            var tokenI = token;
            return {
                decimals: tokenI.data.decimals,
            };
        }
        else if (token.type.toUpperCase() === 'ERC20') {
            var tokenI = token;
            return {
                decimals: tokenI.data.decimals,
                token_address: tokenI.data.tokenAddress,
            };
        }
        else if (token.type.toUpperCase() === 'ERC721') {
            var tokenI = token;
            return {
                token_id: tokenI.data.tokenId,
                token_address: tokenI.data.tokenAddress,
            };
        }
        else if (token.type.toUpperCase() === 'MINTABLE_ERC20') {
            var tokenI = token;
            return {
                token_id: imx_link_crypto_1.getMintingBlobHash(tokenI.data.id, tokenI.data.blueprint),
                token_address: tokenI.data.tokenAddress,
            };
        }
        else if (token.type.toUpperCase() === 'MINTABLE_ERC721') {
            var tokenI = token;
            return {
                token_id: imx_link_crypto_1.getMintingBlobHash(tokenI.data.id, tokenI.data.blueprint),
                token_address: tokenI.data.tokenAddress,
            };
        }
        else {
            throw new Error('Invalid token type');
        }
    };
    ImmutableXClient.prototype.decodeForFunction = function (params, decode, fn) {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = fp_1.valueOrThrow;
                        return [4 /*yield*/, function_1.pipe(decode(params), E.mapLeft(fp_1.errorsToError), TE.fromEither, TE.chain(fn), TE.mapLeft(utils_1.formatError))()];
                    case 1: return [2 /*return*/, _a.apply(void 0, [_b.sent()])];
                }
            });
        });
    };
    return ImmutableXClient;
}());
exports.ImmutableXClient = ImmutableXClient;
exports.default = ImmutableXClient;
//# sourceMappingURL=index.js.map