"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ImmutableXServer = void 0;
var auto_bind_1 = __importDefault(require("auto-bind"));
var ws_1 = __importDefault(require("ws"));
var ImmutableXServer = /** @class */ (function () {
    function ImmutableXServer(log, port) {
        if (port === void 0) { port = 8080; }
        this.log = log;
        this.component = 'ImmutableXServer';
        this.log.debug(this.component, 'Immutable X Web Socket Server');
        this.wss = new ws_1.default.Server({ port: port });
        auto_bind_1.default(this);
        this.wss.on('connection', this.handleConnection);
    }
    ImmutableXServer.prototype.handleConnection = function (socket, req) {
        var _this = this;
        this.log.debug(this.component, "Connected to " + req.socket.remoteAddress + "...");
        socket.isAlive = true;
        socket.on('message', this.handleMessage);
        socket.on('close', function () {
            _this.log.debug(_this.component, "Disconnected from " + req.socket.remoteAddress + "...");
        });
    };
    ImmutableXServer.prototype.handleMessage = function (message) {
        this.log.debug(this.component, message);
        this.wss.clients.forEach(function (client) {
            if (client.readyState === ws_1.default.OPEN) {
                client.send(message);
            }
        });
    };
    return ImmutableXServer;
}());
exports.ImmutableXServer = ImmutableXServer;
exports.default = ImmutableXServer;
//# sourceMappingURL=index.js.map