import ImmutableXController from "../controller";
import { Signer } from '@ethersproject/abstract-signer';
import { PopulatedTransaction } from '@ethersproject/contracts';
import { Token } from '@imtbl/imx-link-types';
import { BigNumber } from 'ethers';
import * as TE from 'fp-ts/TaskEither';
/**
 * Immutable X Wallet
 */
export declare class ImmutableXWallet {
    controller: ImmutableXController;
    private signer;
    private gasLimit?;
    private gasPrice?;
    constructor(signer: Signer, gasLimit?: BigNumber, gasPrice?: BigNumber, accountMappingKey?: string);
    incrementNonce(): void;
    getEthKey(contractAddress: string, starkPublicKey: string): TE.TaskEither<Error, string>;
    getDepositBalance(contractAddress: string, starkPublicKey: string, token: Token, vaultId: string): Promise<string>;
    getWithdrawalBalance(contractAddress: string, starkPublicKey: string, token: Token): Promise<string>;
    sendTransactionF(unsignedTrx: PopulatedTransaction): TE.TaskEither<Error, string>;
    sendTransaction(unsignedTrx: PopulatedTransaction): Promise<string>;
}
export default ImmutableXWallet;
//# sourceMappingURL=index.d.ts.map