"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ImmutableXWallet = void 0;
var controller_1 = __importDefault(require("../controller"));
var experimental_1 = require("@ethersproject/experimental");
var imx_link_crypto_1 = require("@imtbl/imx-link-crypto");
var fp_1 = require("../../libs/fp");
var auto_bind_1 = __importDefault(require("auto-bind"));
var function_1 = require("fp-ts/function");
var TE = __importStar(require("fp-ts/TaskEither"));
/**
 * Immutable X Wallet
 */
var ImmutableXWallet = /** @class */ (function () {
    function ImmutableXWallet(signer, gasLimit, gasPrice, accountMappingKey) {
        if (!signer.provider) {
            throw new Error('Signer is required to have a provider!');
        }
        this.signer = new experimental_1.NonceManager(signer);
        this.controller = new controller_1.default(this.signer, accountMappingKey);
        this.gasLimit = gasLimit;
        this.gasPrice = gasPrice;
        auto_bind_1.default(this);
    }
    ImmutableXWallet.prototype.incrementNonce = function () {
        if (this.signer instanceof experimental_1.NonceManager)
            this.signer.incrementTransactionCount();
    };
    ImmutableXWallet.prototype.getEthKey = function (contractAddress, starkPublicKey) {
        var exchangeContract = this.controller.getExchangeContract(contractAddress);
        return fp_1.taskEitherWithError(function () { return exchangeContract.getEthKey(starkPublicKey); });
    };
    ImmutableXWallet.prototype.getDepositBalance = function (contractAddress, starkPublicKey, token, vaultId) {
        return __awaiter(this, void 0, void 0, function () {
            var exchangeContract, assetId;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        exchangeContract = this.controller.getExchangeContract(contractAddress);
                        assetId = imx_link_crypto_1.getAssetID(token).toUint().val;
                        return [4 /*yield*/, exchangeContract.getQuantizedDepositBalance(starkPublicKey, assetId, vaultId)];
                    case 1: return [4 /*yield*/, (_a.sent()).toString()];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    ImmutableXWallet.prototype.getWithdrawalBalance = function (contractAddress, starkPublicKey, token) {
        return __awaiter(this, void 0, void 0, function () {
            var exchangeContract, assetId;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        exchangeContract = this.controller.getExchangeContract(contractAddress);
                        assetId = imx_link_crypto_1.getAssetID(token).toUint().val;
                        return [4 /*yield*/, exchangeContract.getWithdrawalBalance(starkPublicKey, assetId)];
                    case 1: return [4 /*yield*/, (_a.sent()).toString()];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    ImmutableXWallet.prototype.sendTransactionF = function (unsignedTrx) {
        var _this = this;
        return function_1.pipe(this.gasPrice && this.gasLimit
            ? __assign(__assign({}, unsignedTrx), { gasPrice: this.gasPrice.toHexString(), gasLimit: this.gasLimit.toHexString() }) : unsignedTrx, function (trx) { return fp_1.taskEitherWithError(function () { return _this.signer.sendTransaction(trx); }); }, TE.chain(function (r) {
            _this.incrementNonce();
            return TE.of(r.hash);
        }));
    };
    ImmutableXWallet.prototype.sendTransaction = function (unsignedTrx) {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = fp_1.valueOrThrow;
                        return [4 /*yield*/, this.sendTransactionF(unsignedTrx)()];
                    case 1: return [2 /*return*/, _a.apply(void 0, [_b.sent()])];
                }
            });
        });
    };
    return ImmutableXWallet;
}());
exports.ImmutableXWallet = ImmutableXWallet;
exports.default = ImmutableXWallet;
//# sourceMappingURL=index.js.map